package geniusweb.protocol.session;

import java.util.List;

import com.fasterxml.jackson.annotation.JsonAutoDetect;
import com.fasterxml.jackson.annotation.JsonAutoDetect.Visibility;
import com.fasterxml.jackson.annotation.JsonSubTypes;

import geniusweb.protocol.session.shaop.ShaopTeam;
import geniusweb.references.PartyWithProfile;

/**
 * Contains a functional team, eg in SHAOP a team would be a SHAOP together with
 * his COB partner. In SAOP this is just a SAOP party.
 * 
 * This is needed to specify the general SessionSettings functionality in a
 * sufficient general way
 *
 */
@JsonAutoDetect(fieldVisibility = Visibility.ANY, getterVisibility = Visibility.NONE, setterVisibility = Visibility.NONE)
// we do not use JsonTypeInfo because we always use a specific Team within a protocol
// and do not (de)serialize individual TeamOfPartiesAndProfiles.
//@JsonTypeInfo(use = JsonTypeInfo.Id.NAME, include = JsonTypeInfo.As.WRAPPER_OBJECT)
@JsonSubTypes({ @JsonSubTypes.Type(value = OnePartyTeam.class),
		@JsonSubTypes.Type(value = ShaopTeam.class) })
public interface TeamOfPartiesAndProfiles {
	/**
	 * 
	 * @return the list of all parties involved, which is the parties in all
	 *         teams combined.
	 */
	List<PartyWithProfile> getAllParties();
}
